public class Haupt {
    public static void main() {
        int p = 13;
        int g = 8;
        int a = 5;
        int b = 12;
        int x,y,s1, s2;
        
        System.out.println("Diffie-Hellman-Helfer");
        System.out.println("---------------------");
        System.out.println("");
        System.out.println("g="+g+" p="+p);
        System.out.println("Alices geheime Zahl: a="+a);
        System.out.println("Bobs   geheime Zahl: b="+b);
        System.out.println("");
        
        x = expmod(g,a,p);
        y = expmod(g,b,p);
        
        System.out.println("Alice berechnet x:"+x);
        System.out.println("Bob   berechnet y:"+y);
        
        s1 = expmod(y,a,p);
        s2 = expmod(x,b,p);
        
        System.out.println("Alice berechnet s:"+s1);
        System.out.println("Bob   berechnet s:"+s2);
        
        System.out.println("");
        System.out.println("Angreifer Carlo kennt nur g,p,x und y.");
        System.out.println("Angreifer Carlo versucht a durch probieren herauszufinden.");
        System.out.println("(Die Probierkandidaten sind hier nun i)");
        
        for(int i = 1; i < p; i++) {
            System.out.println("Probiere g^i mod p = "+g+"^"+i+" mod "+p+" = "+expmod(g,i,p));
            if(expmod(g,i,p) == x) {
                System.out.println("    Eine (mögliche) geheime Zahl a von Alice lautet: "+i);
                System.out.println("    Carlo rechnet: s=(y^a) mod p = "+y+"^"+i+" mod "+p+" = "+expmod(y,i,p));
            }
        }
      
    }
    
    static int expmod(int g, int a, int p) {
        int result = 1;
        for(int i = 0; i < a; i++) {
            result = (result * g)%p;
        }
        return result;
    }
}
